
using StandaloneIpopt, LinearAlgebra, ForwardDiff

const M = Symmetric([exp(-abs(x-y)) for x in 1:10, y in 1:10])
const c = [cos(x) for x in 1:10]
obj(v)  = dot(v, M, v) + dot(v, c)
objg(buf, v) = ForwardDiff.gradient!(buf, obj, v) # in-place! 

res_nl  = ipopt_nlsolve(objg, normalize(ones(length(c))))

