
struct NoConstraints end

struct Constraints{F} <: Function
  ncon::Int64
  fun::F
  box_lower::Vector{Float64}
  box_upper::Vector{Float64}
end

function (cons::Constraints{F})(p, store) where{F}
  iszero(cons.ncon) && return nothing
  cons.fun(store, p)
end

noconstraints() = Constraints(0, NoConstraints(), Float64[], Float64[])

